--[[
       --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


      #           #   ###########        #######           ####       #         #  ##   ###########        #           #   #   #######      ###########
      #           #   #                  #      ##       ##    ##     ##        #   ##       #             #           #   #   #      ##    #
      #           #   #                  #        #     #        #    # #       #    ##      #             #           #   #   #        #   #
      #     #     #   #                  #         #   #          #   #  ##     #            #             #     #     #   #   #      ##    #
      #     #     #   ###########        #         #   #          #   #    #    #            #             #     #     #   #   #######      ###########
       #   # #   #    #                  #         #   #          #   #     ##  #            #              #   # #   #    #   #            #
       #   # #   #    #                  #        #     #        #    #       # #            #              #   # #   #    #   #            #
        # #   # #     #                  #      ##       ##    ##     #        ##            #               # #   # #     #   #            #
         #     #      ###########        #######           ####       #         #            #                #     #      #   #            ###########


      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


                                                             ----o----(||)----o----(||)----o----

                                                                      HAVOC DEMON HUNTER
                                                                      ~~~~~~~~~~~~~~~~~~

                                                                   v1.05 1st November 2016
                                                                  Copyright (C) Chris Birch

                                                             ----o----(||)----o----(||)----o----


               Note: This is a module for the We Don't Wipe AddOn. You need to download the latest We Don't Wipe in order to use this module
]]


--[[ ================== ]]--
--[[     Local Data     ]]-- ===============================================================================================================
--[[ ================== ]]-- 

local anguish, fury, ignore, overshoot, range, wait, uptoyou = "y", "y", "n", "n", 0, 0.4, -34249

local playerLevel = 0
local nextPos, elapsedNextPos = 1, 0
local furyCurrent, furyMax = 0, 100

local momentumKnown, expiresMomentum = true, 0
local preparedKnown, expiresPrepared = true, 0
local expiresMetamorphosis = 0
local felMasteryKnown, demonBladesKnown, demonicKnown, blindFuryKnown = false, false, false, false

local hyRange, hyMin, overshootMin = false, 0, 0
local curChargesFR, startChargesFR, durationChargesFR, chargeReadyFR, cdLeftFR = 0, 0, 0, 0, 0
local FelBarrageCharges = 0
local hy_colour_X11Chocolate = "\124cFFD2691E"	-- HardYards chat line prefix colour

local cdLeftMeta, cdLeftEyeBeam, cdLeftFelblade = -2, -2, -2
local cdLeftDance, cdLeftThrow1, cdLeftBarrage1, cdLeftAnnih1, cdLeftSweep, cdLeftChaosS, cdLeftVR = -2, -2, -2, -2, -2, -2, -2

local abs = math.abs
local GetSpellCharges = GetSpellCharges
local GetTalentInfo = GetTalentInfo
local GetTime = GetTime
local IsSpellKnown = IsSpellKnown
local UnitDetailedThreatSituation = UnitDetailedThreatSituation
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax
local UnitLevel = UnitLevel

--[[ ================ ]]--
--[[     Rotation     ]]-- =================================================================================================================
--[[ ================ ]]-- 

wdwMod_Rotations["Havoc"] = {}
wdwMod_Rotations["Havoc"]["Single"] = {

	["Version"] = "1.05",
	["WDW Version"] = "5.10",
	["Hard Yards Version"] = "2.07",
	["Template"] = "1.05",

	["Rotation"] = { "Setup", "EyeBeam1", "Meta", "Vengeful", "FelRush1", "EyeDem", "Eruption", "FotI", "Pre102",
			"Dance", "Felblade", "ThrowBlood", "Barrage#1", "EyeBeam2", "ChaosS", "Barrage#2", "Bite", "Range", "Final", },
	["Parameters"] = {"DB", "List", "anguish", "fury", "ignore", "overshoot", "range", "wait", "uptoyou", },
	["Notes"] = "Legion Patch 7.1 - Return to Karahzan",

	["anguish"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "anguish".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_HavocDB.anguish or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". You are using Anguish of the Deceiver as an Artifact Trait. "..
					wdw_colour_SelectiveYellow.. "Default \"y\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_HavocDB[ "anguish" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_HavocDB[ "anguish" ] then
			WDW_HavocDB[ "anguish" ] = "y"
		end
		anguish = WDW_HavocDB[ "anguish" ]
	end,

	["fury"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "fury".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_HavocDB.fury or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Fury of the Illidari. "..
					wdw_colour_SelectiveYellow.. "Default \"y\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_HavocDB[ "fury" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_HavocDB[ "fury" ] then
			WDW_HavocDB[ "fury" ] = "y"
		end
		fury = WDW_HavocDB[ "fury" ]
	end,

	["overshoot"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "overshoot".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_HavocDB.overshoot or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Fel Rush damages anything along its 15 yard path. Is it okay to "..
					"jump past your target, landing facing away (and perhaps outside melee range)? "..
					wdw_colour_SelectiveYellow.. "Default \"n\"".. wdw_colour_Jasmine.. ". Requires the ".. 
					hy_colour_X11Chocolate.. "Hard Yards".. wdw_colour_Jasmine.. " AddOn)" )
				return
			end
			WDW_HavocDB[ "overshoot" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_HavocDB[ "overshoot" ] then
			WDW_HavocDB[ "overshoot" ] = "y"
		end
		overshoot = WDW_HavocDB[ "overshoot" ]
	end,

	["ignore"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "ignore".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_HavocDB.ignore or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Always assume the player is within range. Ignore Hard Yards data, "..
					"and the \"overshoot\" and \"range\" parameters. "..
					wdw_colour_SelectiveYellow.. "Default \"n\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_HavocDB[ "ignore" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_HavocDB[ "ignore" ] then
			WDW_HavocDB[ "ignore" ] = "n"
		end
		ignore = WDW_HavocDB[ "ignore" ]
	end,

	["range"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "range".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_HavocDB.range or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "0".. wdw_colour_Jasmine.. " to ".. wdw_colour_SelectiveYellow..
					"20".. wdw_colour_Jasmine.. " yards. An ability must be in range so that it may appear in the "..
					"queue. If, for example, it is okay to be 5 yards outside of range then set this parameter to "..
					"\"5\". Requires the ".. hy_colour_X11Chocolate.. "Hard Yards".. wdw_colour_Jasmine.. " AddOn)" )
				return
			end
			local yards = tonumber( arg )
			WDW_HavocDB[ "range" ] = ( ( yards >= 0 ) and ( yards <= 20 ) ) and yards or 0
		end
		if not WDW_HavocDB[ "range" ] then
			WDW_HavocDB[ "range" ] = 0
		end
		range = WDW_HavocDB[ "range" ]
	end,

	["wait"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "wait".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_HavocDB.wait or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "0".. wdw_colour_Jasmine.. " to ".. wdw_colour_SelectiveYellow..
					"1.5".. wdw_colour_Jasmine.. " seconds. At times an ability might not be exactly ready to use as "..
					"it is cooling down or recharging. The default is to allow an ability to appear in its queue "..
					"position up to 400ms before it is ready. "..
					wdw_colour_SelectiveYellow.. "Default \"0.4\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			local waitAmount = tonumber( arg )
			WDW_HavocDB[ "wait" ] = ( ( waitAmount >= 0 ) and ( waitAmount <= 1.5 ) ) and waitAmount or 0.4
		end
		if not WDW_HavocDB[ "wait" ] then
			WDW_HavocDB[ "wait" ] = 0.4
		end
		wait = WDW_HavocDB[ "wait" ]
	end,

	["uptoyou"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "uptoyou".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_HavocDB.uptoyou or "nil").. wdw_colour_Jasmine..
					" (Specify a spell or item ID obtained from www.wowhead.com. Its ICON will be used. For an ITEM "..
					"make the number negative. "..
					wdw_colour_SelectiveYellow.. "Default \"-34249\"".. wdw_colour_Jasmine.. ", the \"Hula Girl\""..
					" toy item)" )
				return
			end
			local spellItemID = tonumber( arg )
			WDW_HavocDB[ "uptoyou" ] = ( spellItemID ~= 0 ) and spellItemID or -34249
		end
		if not WDW_HavocDB[ "uptoyou" ] then
			WDW_HavocDB[ "uptoyou" ] = -34249					-- Hula Girl Doll
		end
		uptoyou = WDW_HavocDB[ "uptoyou" ]
	end,

	["DB"] = function ()

		if not WDW_HavocDB then WDW_HavocDB = {} return end
		if ( WDW_HavocDB.range ~= nil ) then
			WDW_HavocDB.range = ( WDW_HavocDB.range < 0 ) and 0 or WDW_HavocDB.range
		end
	end,

	["List"] = function ()

		print( wdw_colour_SelectiveYellow.. "Havoc Demon Hunter parameters:\n"..
			wdw_colour_MalachiteGreen.. "anguish".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( anguish or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "fury".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( fury or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "ignore".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( ignore or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "overshoot".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( overshoot or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "range".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( range or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "wait".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( wait or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "uptoyou".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( uptoyou or "nil" ) ) 
	end,

	["Setup"] = function ()

		playerLevel = UnitLevel( "player" )

		nextPos, elapsedNextPos = 1, wdw_GCD

		furyCurrent = UnitPower( "player", SPELL_POWER_FURY )
		furyMax = UnitPowerMax( "player", SPELL_POWER_FURY )

		if ( playerLevel >= 106 ) and ( select( 4, GetTalentInfo( 5, 1, 1 ) ) == true ) then
			momentumKnown = true
			expiresMomentum = wdw_buffsPlayer["208628"] and wdw_buffsPlayer["208628"].expires or 0
		else
			momentumKnown = false
			expiresMomentum = 0
		end

		if ( playerLevel >= 100 ) and ( select( 4, GetTalentInfo( 2, 1, 1 ) ) == true ) then
			preparedKnown = true
			expiresPrepared = wdw_buffsPlayer["203650"] and wdw_buffsPlayer["203650"].expires or 0
		else
			preparedKnown = false
			expiresPrepared = 0
		end

		if ( IsSpellKnown( 191427 ) == true ) then
			expiresMetamorphosis = wdw_buffsPlayer["162264"] and wdw_buffsPlayer["162264"].expires or 0
			cdLeftMeta = WeDontWipe_CooldownLeft( 191427 )
		else
			cdLeftMeta = -2
		end

		if ( IsSpellKnown( 198013 ) == true ) then
			cdLeftEyeBeam = WeDontWipe_CooldownLeft( 198013 )
			demonicKnown = select( 4, GetTalentInfo( 7, 3, 1 ) )
		else
			cdLeftEyeBeam = -2
			demonicKnown = false
		end

		blindFuryKnown = select( 4, GetTalentInfo( 1, 3, 1 ) )
		demonBladesKnown = select( 4, GetTalentInfo( 2, 2, 1 ) )
		felMasteryKnown = select( 4, GetTalentInfo( 1, 1, 1 ) )

		if ( select( 4, GetTalentInfo( 3, 1, 1 ) ) == true ) then
			cdLeftFelblade = WeDontWipe_CooldownLeft( 213241 )
		else
			cdLeftFelblade = -2
		end

		if ( ignore == "y" ) then
			hyRange = true
			hyMin = 0
		else
			if ( HardYards_min ~= nil ) or ( HardYards_max ~= nil ) then
				hyRange = true
				hyMin = ( HardYards_min or 0 ) - range
				hyMin = ( hyMin < 0 ) and 0 or hyMin
				overshootMin = ( HardYards_min or 0 ) + range
			else
				hyRange = false
			end
		end

		curChargesFR, _, startChargesFR, durationChargesFR = GetSpellCharges( 195072 )
		chargeReadyFR = ( startChargesFR == 2 ) and 0 or ( startChargesFR + durationChargesFR - GetTime() )
		cdLeftFR = ( curChargesFR > 0 ) and WeDontWipe_CooldownLeft( 195072 ) or chargeReadyFR

		FelBarrageCharges = 0

		cdLeftDance, cdLeftThrow1, cdLeftBarrage1, cdLeftAnnih1, cdLeftSweep, cdLeftChaosS, cdLeftVR = -2, -2, -2, -2, -2, -2, -2
	end,

	["EyeBeam1"] = function ()	-- Eye Beam. Cost 50 Fury. 45s CD, GCD, Channeled for 2s. Reward from quest 39049. 20 yards

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin  > 20 ) or ( cdLeftEyeBeam < 0 ) or ( expiresMetamorphosis > elapsedNextPos ) then return end

		if ( felMasteryKnown == true ) or ( preparedKnown == true ) or ( momentumKnown == true ) or
				( select( 4, GetTalentInfo( 7, 1, 1 ) ) == true ) or						-- Chaos Blades talent
				( select( 4, GetTalentInfo( 7, 2, 1 ) ) == true ) or						-- Fel Barrage talent
				( select( 4, GetTalentInfo( 5, 2, 1 ) ) == true ) or						-- Fel Eruption talent
				( select( 4, GetTalentInfo( 1, 2, 1 ) ) == true ) then						-- Chaos Cleave talent
			return
		end

		if ( furyCurrent < 50 ) and ( ( cdLeftEyeBeam - wait - wdw_GCDtop ) < elapsedNextPos )  then
			if ( furyCurrent >= 20 ) and ( hyMin  < 15 ) and ( cdLeftFelblade >= 0 ) and ( ( cdLeftFelblade - wait ) < elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 213241									-- Felblade
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 30
				else
					furyCurrent = furyCurrent + 30
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				cdLeftFelblade = -1
				hyMin = 0
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
			elseif  ( demonBladesKnown == false ) and ( furyCurrent >= 30 ) and ( hyMin  < 5 ) then
				wdw_Queue[ nextPos ] = 162243									-- Demon's Bite
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 25
				else
					furyCurrent = furyCurrent + 25
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
			else
				return
			end
		end

		if ( furyCurrent >= 50 ) and ( ( cdLeftEyeBeam - wait ) < elapsedNextPos )  then
			wdw_Queue[ nextPos ] = 198013										-- Eye Beam
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + 16 - 50 + ( ( blindFuryKnown == true ) and 8 or 0 )
			else
				furyCurrent = furyCurrent - 50 + ( ( blindFuryKnown == true ) and 8 or 0 )
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + 2 + wdw_GCDtop + ( ( blindFuryKnown == true ) and 1 or 0 )
			if ( demonicKnown == true ) then
				expiresMetamorphosis = 5 - wdw_GCDtop
				-- shouldn't need to set a cool down
			end
			cdLeftEyeBeam = -1
		end
	end,

	["Meta"] = function ()	-- Metamorphosis. 300s cd. GCD. Quest reward @ about L98/99. 40 yards leap, 8 yard splash

		if ( nextPos > WeDontWipeDB.queueLength ) or ( cdLeftMeta == -2 ) or ( hyRange == false ) then return end

		if ( select( 4, GetTalentInfo( 5, 3, 1 ) ) == true ) and ( hyMin  <= 50 ) then	-- Nemesis. Level 106 talent. 120s CD, GCD. lasts 60s
			local cdLeftN = WeDontWipe_CooldownLeft( 206491 )
			if ( cdLeftN - wait ) < elapsedNextPos then
				if ( ( expiresMetamorphosis - 7 ) > elapsedNextPos ) then
					-- To here if Nemesis available and Meta is active
					-- An Eye Beam Meta has a 2+5=7s expiry
					wdw_Queue[ nextPos ] = 206491								-- Nemesis
					if ( expiresPrepared > elapsedNextPos ) then
						furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 )
						furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
					end
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					if ( nextPos > WeDontWipeDB.queueLength ) then return end

				elseif ( cdLeftMeta - wait ) < elapsedNextPos then
--[[
					-- To here if Nemesis available and Meta available
					wdw_Queue[ nextPos ] = 206491								-- Nemesis
					if ( expiresPrepared > elapsedNextPos ) then
						furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 )
						furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
					end
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
					wdw_Queue[ nextPos ] = 191427								-- Metamorphosis
					if ( expiresPrepared > elapsedNextPos ) then
						furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 )
						furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
					end
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
]]
				end

			elseif wdw_buffsPlayer["206491"] then
				if ( wdw_buffsPlayer["206491"].expires > elapsedNextPos ) then
					-- To here if has Nemesis buff
					if ( expiresMetamorphosis > elapsedNextPos ) then
						-- To here if has Nemesis buff and Meta active
					elseif ( cdLeftMeta - wait ) < elapsedNextPos then
						-- To here if has Nemesis buff and Meta available
						wdw_Queue[ nextPos ] = 191427							-- Metamorphosis
						if ( expiresPrepared > elapsedNextPos ) then
							furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 )
							furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
						end
						nextPos = nextPos + 1
						elapsedNextPos = elapsedNextPos + wdw_GCDtop
						if ( nextPos > WeDontWipeDB.queueLength ) then return end
					end
				end
			end
		end

		if ( expiresMetamorphosis > elapsedNextPos ) then
			local cdLeftCB = ( select( 4, GetTalentInfo( 7, 1, 1 ) ) == true ) and WeDontWipe_CooldownLeft( 211048 ) or 1000
			if ( cdLeftCB - wait ) < elapsedNextPos then
				wdw_Queue[ nextPos ] = 211048									-- Chaos Blades
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + 0.05
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
			end
		end

		if ( expiresMetamorphosis > elapsedNextPos ) and ( hyMin  < 15 ) and ( furyCurrent < 35 )  and ( cdLeftFelblade >= 0 ) and ( ( cdLeftFelblade - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 213241										-- Felblade
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 30
			else
				furyCurrent = furyCurrent + 30
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			cdLeftFelblade = -1
			hyMin = 0
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end

		if ( expiresMetamorphosis > elapsedNextPos ) and ( hyMin  < 5 ) and ( furyCurrent < 35 ) and ( demonBladesKnown == false ) then
			wdw_Queue[ nextPos ] = 162243										-- Demon's Bite
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 25
			else
				furyCurrent = furyCurrent + 25
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end

		local cdLeftDS = ( IsSpellKnown( 210152 ) == true ) and WeDontWipe_CooldownLeft( 210152 ) or 1000

		if ( expiresMetamorphosis > elapsedNextPos ) and ( hyMin  < 8 ) and ( furyCurrent >= 35 ) and ( ( cdLeftDS - wait ) < elapsedNextPos ) then
			-- Death Sweep. 35 Fury cost, 8s CD, GCD, 8 yards
			wdw_Queue[ nextPos ] = 210152										-- Death Sweep
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) - 35
			else
				furyCurrent = furyCurrent - 35
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			cdLeftSweep = -1
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end

		if ( expiresMetamorphosis > elapsedNextPos ) and ( hyMin  < 15 ) and ( furyCurrent < 40 )  and ( cdLeftFelblade >= 0 ) and ( ( cdLeftFelblade - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 213241										-- Felblade
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 30
			else
				furyCurrent = furyCurrent + 30
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			cdLeftFelblade = -1
			hyMin = 0
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end

		if ( expiresMetamorphosis > elapsedNextPos ) and ( hyMin  < 5 ) and ( furyCurrent < 35 ) and ( demonBladesKnown == false ) then
			wdw_Queue[ nextPos ] = 162243										-- Demon's Bite
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 25
			else
				furyCurrent = furyCurrent + 25
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end

		local cdLeftA = ( IsSpellKnown( 201427 ) == true ) and WeDontWipe_CooldownLeft( 201427 ) or 1000

		if ( expiresMetamorphosis > elapsedNextPos ) and ( hyMin  < 5 ) and ( furyCurrent >= 40 ) and ( ( cdLeftA - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 201427										-- Annihilation
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) - 40
			else
				furyCurrent = furyCurrent - 40
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			cdLeftAnnih1 = -1
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end

		if ( expiresMetamorphosis > elapsedNextPos ) and ( hyMin  < 15 ) and ( furyCurrent < 40 )  and ( cdLeftFelblade >= 0 ) and ( ( cdLeftFelblade - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 213241										-- Felblade
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 30
			else
				furyCurrent = furyCurrent + 30
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			cdLeftFelblade = -1
			hyMin = 0
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end

		if ( expiresMetamorphosis > elapsedNextPos ) and ( hyMin  < 5 ) and ( furyCurrent < 35 ) and ( demonBladesKnown == false ) then
			wdw_Queue[ nextPos ] = 162243										-- Demon's Bite
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 25
			else
				furyCurrent = furyCurrent + 25
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
		end

		if ( expiresMetamorphosis > elapsedNextPos ) and ( hyMin  < 5 ) and ( furyCurrent >= 40 ) and ( ( cdLeftA - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 201427										-- Annihilation
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) - 40
			else
				furyCurrent = furyCurrent - 40
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			cdLeftAnnih1 = -1
		end
	end,

	["Vengeful"] = function ()	-- Vengeful Retreat. 5 yard splash and then 15 yard jump back. Starter Zone quest reward. 25s CD, lasts 1s

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin  > 5 ) or ( IsSpellKnown( 198793 ) == false ) then return end

		cdLeftVR = WeDontWipe_CooldownLeft( 198793 )

		if ( cdLeftVR - wait ) <= elapsedNextPos then

			if ( preparedKnown == true ) and ( ( furyCurrent + 20 ) < furyMax ) then
				-- assumes we won't spend Fury for about two GCDs with Prepared active and no other source
				wdw_Queue[ nextPos ] = 198793
				expiresPrepared = 5 + elapsedNextPos
				-- Fury gain over 0.05s = 0.4 assuming constant and not ticked. i.e. negligible
				if ( momentumKnown == true ) then
					expiresMomentum = 4 + elapsedNextPos
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + 0.05
				cdLeftVR = -1
				hyMin = ( ignore == "y" ) and 0 or ( hyMin + 15 )

			elseif ( momentumKnown == true ) and ( ( expiresMomentum - wait ) <= elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 198793
				if ( preparedKnown == true ) then
					expiresPrepared = 5 + elapsedNextPos
				end
				expiresMomentum = 4 + elapsedNextPos
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + 0.05
				cdLeftVR = -1
				hyMin = ( ignore == "y" ) and 0 or ( hyMin + 15 )

			elseif ( playerLevel < 100 ) then
				wdw_Queue[ nextPos ] = 198793
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + 0.05
				cdLeftVR = -1
				hyMin = ( ignore == "y" ) and 0 or ( hyMin + 15 )
			end
		end
	end,

	["FelRush1"] = function ()	-- Fel Rush. Starter spell. 1s CD, 250ms GCD, 15 yard surge. Damage within melee range. 2 charges, 10s recharge

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin > 20 ) then return end
		if ( overshoot == "n" ) and ( overshootMin < 10 ) then return end

		if ( cdLeftFR - wait ) < elapsedNextPos then

			if ( felMasteryKnown == true ) then

				if ( furyCurrent + 25 ) <= furyMax then
					wdw_Queue[ nextPos ] = 195072
					if ( expiresPrepared > elapsedNextPos ) then
						furyCurrent = furyCurrent + 27	-- ( 25 + 40 * .25 / 5 )
					else
						furyCurrent = furyCurrent + 25
					end
					furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
					if ( momentumKnown == true ) then
						expiresMomentum = 4 + elapsedNextPos
					end
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + 0.25
					cdLeftFR = -1
					hyMin = ( ignore == "y" ) and 0 or ( hyMin - 15 )
				end

			elseif ( curChargesFR == 2 ) or ( ( curChargesFR == 1 ) and ( chargeReadyFR <= elapsedNextPos ) ) then
				wdw_Queue[ nextPos ] = 195072
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = ( ( furyCurrent + 2 ) > furyMax ) and furyMax or ( furyCurrent + 2 )
				end
				if ( momentumKnown == true ) then
					expiresMomentum = 4 + elapsedNextPos
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + 0.25
				cdLeftFR = -1
				hyMin = ( ignore == "y" ) and 0 or ( hyMin + 15 )

			elseif ( momentumKnown == true ) and ( ( expiresMomentum - wait ) <= elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 195072
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = ( ( furyCurrent + 2 ) > furyMax ) and furyMax or ( furyCurrent + 2 )
				end
				expiresMomentum = 4 + elapsedNextPos
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + 0.25
				cdLeftFR = -1
				hyMin = ( ignore == "y" ) and 0 or ( hyMin + 15 )

			elseif select( 4, UnitDetailedThreatSituation( "player", "target" ) ) or wdw_trainingDummy then
			elseif ( overshoot == "y" ) or ( overshootMin >= 10 ) then
				wdw_Queue[ nextPos ] = 195072
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = ( ( furyCurrent + 2 ) > furyMax ) and furyMax or ( furyCurrent + 2 )
				end
				if ( momentumKnown == true ) then
					expiresMomentum = 4 + elapsedNextPos
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + 0.25
				cdLeftFR = -1
				hyMin = ( ignore == "y" ) and 0 or ( hyMin + 15 )
			end
		end
	end,

	["EyeDem"] = function ()	-- Eye Beam. Cost 50 Fury. 45s CD, GCD, Channeled for 2s
					-- Requires Demonic Tier 7 / level 110 talent

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin > 20 ) or ( cdLeftEyeBeam < 0 ) or ( demonicKnown == false ) then return end

		if ( furyCurrent < 50 ) and ( ( cdLeftEyeBeam - wait - wdw_GCDtop ) < elapsedNextPos )  then
			if ( furyCurrent >= 20 ) and ( hyMin  < 15 ) and ( cdLeftFelblade >= 0 ) and ( ( cdLeftFelblade - wait ) < elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 213241									-- Felblade
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 30
				else
					furyCurrent = furyCurrent + 30
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				cdLeftFelblade = -1
				hyMin = 0
			elseif ( demonBladesKnown == false ) and ( furyCurrent >= 30 ) and ( hyMin  < 5 ) then
				wdw_Queue[ nextPos ] = 162243									-- Demon's Bite
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 25
				else
					furyCurrent = furyCurrent + 25
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
			else
				return
			end
		end

		if ( furyCurrent >= 50 ) and ( ( cdLeftEyeBeam - wait ) < elapsedNextPos )  then
			wdw_Queue[ nextPos ] = 198013										-- Eye Beam
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + 16 - 50 + ( ( blindFuryKnown == true ) and 8 or 0 )
			else
				furyCurrent = furyCurrent - 50 + ( ( blindFuryKnown == true ) and 8 or 0 )
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + 2 + wdw_GCDtop + ( ( blindFuryKnown == true ) and 1 or 0 )
			expiresMetamorphosis = 5 - wdw_GCDtop	-- shouldn't need to set a cool down
			cdLeftEyeBeam = -1

-- TO DO: Metamorphosis code to make the rotation look better. As it is, non-meta stuff will appear and imply WDW is unaware that a Meta is imminent

		end
	end,

	["Eruption"] = function ()	-- Fel Eruption. Costs 20 Fury. 35s CD, GCD. 2s duration

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin > 20 ) or ( select( 4, GetTalentInfo( 5, 2, 1 ) ) == false ) then return end

		local cdLeft = WeDontWipe_CooldownLeft( 211881 )

		if ( furyCurrent < 20 ) and ( ( cdLeft - wait - wdw_GCDtop ) < elapsedNextPos )  then
			if ( hyMin  < 15 ) and ( cdLeftFelblade >= 0 ) and ( ( cdLeftFelblade - wait ) < elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 213241									-- Felblade
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 30
				else
					furyCurrent = furyCurrent + 30
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				cdLeftFelblade = -1
				hyMin = 0
			elseif ( demonBladesKnown == false ) and ( hyMin  < 5 ) then
				wdw_Queue[ nextPos ] = 162243									-- Demon's Bite
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 25
				else
					furyCurrent = furyCurrent + 25
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
			else
				return
			end
		end

		if ( ( cdLeft - wait ) < elapsedNextPos ) and ( furyCurrent >= 20 ) then
			wdw_Queue[ nextPos ] = 211881										-- Fel Eruption
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) - 20
			else
				furyCurrent = furyCurrent - 20
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["FotI"] = function ()	-- Fury of the Illidari. Artefact. 60s CD. GCD, lasts 3s. Spell known if artefact equipped. 40 yard range at Wowhead etc? Rubbish. 6 yards

		if ( nextPos > WeDontWipeDB.queueLength ) or ( fury == "n" ) or ( hyRange == false ) or ( hyMin > 9 ) or ( IsSpellKnown( 201467 ) == false ) then return end

		local cdLeft = WeDontWipe_CooldownLeft( 201467 )
		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			if ( expiresMomentum > elapsedNextPos ) or ( momentumKnown == false ) then
				wdw_Queue[ nextPos ] = 201467
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 )
					furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
			end
		end
	end,

	["Pre102"] = function ()	-- Prior to Tier 3 or if player didn't select a talent
					-- Chaos Strike. Cost 40 Fury. GCD. Melee. Starting ability
					-- Throw Glaive. GCD. 10s recharge. 30 yards. Reward from quest 39495
					-- Blade Dance. Level 99. Costs 35 Fury (15 with First Blood). 10s CD, GCD, 1s duration. 8 yards radius

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) then return end

		if ( playerLevel < 102 ) or  ( ( select( 4, GetTalentInfo( 3, 1, 1 ) ) == false ) and ( select( 4, GetTalentInfo( 3, 2, 1 ) ) == false ) and
													( select( 4, GetTalentInfo( 3, 3, 1 ) ) == false ) ) then
		else
			return
		end

		if ( cdLeftAnnih1 == -2 ) and ( furyCurrent >= 20 ) and ( hyMin  < 5 ) then
			local cdLeftCS = WeDontWipe_CooldownLeft( 162794 )
			if ( ( ( cdLeftCS - wait ) < elapsedNextPos ) and ( furyCurrent >= 40 ) ) or ( ( demonBladesKnown == false ) and ( ( cdLeftCS - wait - wdw_GCDtop ) < elapsedNextPos ) and ( furyCurrent < 40 ) ) then
				if ( furyCurrent < 40 ) then
					wdw_Queue[ nextPos ] = 162243								-- Demon's Bite
					furyCurrent = furyCurrent + 25
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
				end
				wdw_Queue[ nextPos ] = 162794									-- Chaos Strike
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) - 40
				else
					furyCurrent = furyCurrent - 40
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				cdLeftChaosS = -1
				return
			end
			cdLeftChaosS = cdLeft
		end

		if ( hyMin  <= 30 ) and ( IsSpellKnown( 185123 ) == true ) then
			local cdLeftTG = WeDontWipe_CooldownLeft( 185123 )
			if ( ( cdLeftTG - wait ) < elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 185123									-- Throw Glaive < 106
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 )
					furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				cdLeftThrow1 = -1
				return
			end
			cdLeftThrow1 = cdLeft
		end

		if ( hyMin  <= 8 ) and ( playerLevel >= 99 ) then
			local cdLeftBD = WeDontWipe_CooldownLeft( 188499 )
			if ( ( ( cdLeftBD - wait ) < elapsedNextPos ) and ( furyCurrent >= 35 ) ) or
					( ( demonBladesKnown == false ) and ( ( cdLeftBD - wait - wdw_GCDtop ) < elapsedNextPos ) and ( furyCurrent < 35 ) and ( furyCurrent >= 15 ) and ( hyMin  <= 8 ) ) then
				if ( furyCurrent < 35 ) then
					wdw_Queue[ nextPos ] = 162243								-- Demon's Bite
					furyCurrent = furyCurrent + 25
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
				end
				wdw_Queue[ nextPos ] = 188499									-- Blade Dance
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) - 35
				else
					furyCurrent = furyCurrent - 35
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				cdLeftDance = -1
				return
			end
			cdLeftDance = cdLeftBD
		end
	end,

	["Dance"] = function ()	-- Blade Dance. Level 99. Costs 35 Fury (15 with First Blood). 10s CD, GCD, 1s duration. 8 yards radius
				-- Logic requires Tier 3 / Level 102 First Blood talent

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin  > 8 ) or ( playerLevel < 102 ) or ( cdLeftDance == -1 ) or ( cdLeftSweep >= -1 ) then return end

		if ( ( expiresMomentum > elapsedNextPos ) or ( momentumKnown == false ) ) and ( select( 4, GetTalentInfo( 3, 2, 1 ) ) == true ) then
			local cdLeft = WeDontWipe_CooldownLeft( 188499 )
			if ( furyCurrent < 15 ) and ( ( cdLeft - wait - wdw_GCDtop ) < elapsedNextPos )  then
				if ( cdLeftFelblade >= 0 ) and ( ( cdLeftFelblade - wait ) < elapsedNextPos ) then
					wdw_Queue[ nextPos ] = 213241								-- Felblade
					if ( expiresPrepared > elapsedNextPos ) then
						furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 30
					else
						furyCurrent = furyCurrent + 30
					end
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					cdLeftFelblade = -1
					hyMin = 0
				elseif ( demonBladesKnown == false ) and ( hyMin  < 5 ) then
					wdw_Queue[ nextPos ] = 162243								-- Demon's Bite
					if ( expiresPrepared > elapsedNextPos ) then
						furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 25
					else
						furyCurrent = furyCurrent + 25
					end
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
				else
					return
				end
			end
			if ( ( cdLeft - wait ) < elapsedNextPos ) and ( furyCurrent >= 15 ) then
				wdw_Queue[ nextPos ] = 188499									-- Blade Dance
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) - 15
				else
					furyCurrent = furyCurrent - 15
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				cdLeftDance = -1
				return
			end
			cdLeftDance = cdLeft
		end
	end,

	["Felblade"] = function ()	-- Felblade. 15s CD, GCD. Generates 30 Fury. 15 yard range
					-- Logic requires Tier 3 / Level 102 Felblade talent

		if ( nextPos > WeDontWipeDB.queueLength ) or ( cdLeftFelblade < 0 ) or ( ( furyCurrent + 30 ) > furyMax ) or ( hyRange == false ) or ( hyMin  > 15 )  then return end

			if ( cdLeftFelblade - wait ) < elapsedNextPos then
				wdw_Queue[ nextPos ] = 213241									-- Felblade
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) + 30
				else
					furyCurrent = furyCurrent + 30
				end
				furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				cdLeftFelblade = -1
				hyMin = 0
			end
	end,

	["ThrowBlood"] = function ()	-- Throw Glaive. GCD. 10s recharge, 1 charge only. 30 yards
					-- Logic requires Tier 3 / Level 102 Bloodlet talent
					-- Master of the Glaive, Tier 6 / level 106 talent - now 2 charges

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin  > 30 ) or ( playerLevel < 102 ) or ( cdLeftThrow1 == -1 ) then return end

		if ( ( expiresMomentum > elapsedNextPos ) or ( momentumKnown == false ) ) and ( select( 4, GetTalentInfo( 3, 3, 1 ) ) == true ) then
			local cdLeftTG = WeDontWipe_CooldownLeft( 185123 )
			if ( ( cdLeftTG - wait ) < elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 185123									-- Throw Glaive
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 )
					furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				cdLeftThrow1 = -1
				return
			end
			cdLeftThrow1 = cdLeft
		end
	end,

	["Barrage#1"] = function ()	-- Fel Barrage. Talent. GCD, Channeled for 1s, 5 charges, 30s recharge, 5s charge/buff duration

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin  > 30 ) or ( playerLevel < 110 ) then return end

		if ( ( expiresMomentum > elapsedNextPos ) or ( momentumKnown == false ) ) and ( select( 4, GetTalentInfo( 7, 2, 1 ) ) == true ) then

			local curCharges, _, startCharges, durationCharges = GetSpellCharges( 211053 )
			local chargeReady = ( startCharges == 0 ) and 0 or ( startCharges + durationCharges - GetTime() )
			local cdLeft = ( curCharges > 0 ) and WeDontWipe_CooldownLeft( 211053 ) or chargeReady
			if ( ( cdLeft - wait ) < elapsedNextPos ) then
				if ( curCharges >= 5 ) then
					wdw_Queue[ nextPos ] = 211053								-- Fel Barrage talent
					if ( expiresPrepared > elapsedNextPos ) then
						furyCurrent = furyCurrent + ( 12 * ( ( wdw_GCDtop / 1.5 ) + 1 ) )
						furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
					end
					nextPos = nextPos + 1
					elapsedNextPos = elapsedNextPos + 1 + wdw_GCDtop
					cdLeftBarrage1 = -1
					return
				end
			end
			cdLeftBarrage1 = cdLeft
			FelBarrageCharges = curCharges
		end
	end,

	["EyeBeam2"] = function ()	-- Eye Beam. Cost 50 Fury. 45s CD, GCD, Channeled for 2s WITH Anguish of the Deceiver trait

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin  > 20 ) or ( furyCurrent < 30 ) or ( cdLeftEyeBeam < 0 ) or
				( ( playerLevel == 110 ) and ( anguish == false ) ) or ( ( demonicKnown == true ) and ( expiresMetamorphosis > elapsedNextPos ) ) then return end

		if ( ( ( cdLeftEyeBeam - wait ) < elapsedNextPos ) and ( furyCurrent >= 50 ) ) or
				( ( demonBladesKnown == false ) and ( ( cdLeftEyeBeam - wait - wdw_GCDtop ) < elapsedNextPos ) and ( furyCurrent < 50 ) and ( hyMin  < 5 ) ) then
			if ( furyCurrent < 50 ) then
				wdw_Queue[ nextPos ] = 162243									-- Demon's Bite
				furyCurrent = furyCurrent + 25
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
			end
			wdw_Queue[ nextPos ] = 198013										-- Eye Beam
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + 16 - 50 + ( ( blindFuryKnown == true ) and 8 or 0 )
			else
				furyCurrent = furyCurrent - 50 + ( ( blindFuryKnown == true ) and 8 or 0 )
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + 2 + wdw_GCDtop + ( ( blindFuryKnown == true ) and 1 or 0 )
			expiresMetamorphosis = 5 - wdw_GCDtop	-- shouldn't need to set a cool down
			cdLeftEyeBeam = -1
		end
	end,

	["ChaosS"] = function ()	-- Chaos Strike. Cost 40 Fury. GCD. Starting ability

		if ( nextPos > WeDontWipeDB.queueLength ) or ( cdLeftAnnih1 == -1 ) or ( cdLeftChaosS == -1 ) or ( hyRange == false ) or ( hyMin  > 5 ) or ( furyCurrent < 20 ) then return end

		local cdLeft = ( cdLeftChaosS >= 0 ) and cdLeftChaosS or WeDontWipe_CooldownLeft( 162794 )
		if ( ( ( cdLeft - wait ) < elapsedNextPos ) and ( furyCurrent >= 40 ) ) or ( ( demonBladesKnown == false ) and ( ( cdLeft - wait - wdw_GCDtop ) < elapsedNextPos ) and ( furyCurrent < 40 ) ) then
			if ( furyCurrent < 40 ) then
				wdw_Queue[ nextPos ] = 162243									-- Demon's Bite
				furyCurrent = furyCurrent + 25
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
			end
			wdw_Queue[ nextPos ] = 162794										-- Chaos Strike
			if ( expiresPrepared > elapsedNextPos ) then
				furyCurrent = furyCurrent + ( 12 * wdw_GCDtop / 1.5 ) - 40
			else
				furyCurrent = furyCurrent - 40
			end
			nextPos = nextPos + 1
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			cdLeftChaosS = -1
			return
		end
		cdLeftChaosS = cdLeft
	end,

	["Barrage#2"] = function ()	-- Fel Barrage. GCD, Channeled for 1s, 5 charges, 30s recharge, 5s charge/buff duration

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin  > 30 ) or ( playerLevel < 110 ) or ( cdLeftBarrage1 == -1 ) then return end

		if ( cdLeftBarrage1 >= 0 ) and ( ( expiresMomentum > elapsedNextPos ) or ( momentumKnown == false ) ) then
			if ( FelBarrageCharges == 4 ) or ( ( FelBarrageCharges == 3 ) and ( ( cdLeftBarrage1 - wait ) < elapsedNextPos ) ) then
				wdw_Queue[ nextPos ] = 211053									-- Fel Barrage talent
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 8 * ( ( wdw_GCDtop / 1.5 ) + 1 ) )
					furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
				end
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop + 1
				return
			end
		end
	end,

	["Bite"] = function ()	-- Demon's Bite. GCD, Creates 20 - 30 Fury. Starting ability

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) or ( hyMin  > 5 ) or ( furyCurrent + 25 > furyMax ) then return end

		if ( demonBladesKnown == false ) then
			local cdLeft = WeDontWipe_CooldownLeft( 162243 )
			if ( ( cdLeft - wait ) < elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 162243									-- Demon's Bite
				if ( expiresPrepared > elapsedNextPos ) then
					furyCurrent = furyCurrent + ( 8 * ( ( wdw_GCDtop / 1.5 ) + 1 ) ) + 25
				else
					furyCurrent = furyCurrent + 25
				end
				furyCurrent = ( furyCurrent > furyMax ) and furyMax or furyCurrent
				nextPos = nextPos + 1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
			end
		end
	end,

	["Range"] = function ()	-- Filler. This section attempts to fill with something from the rotation, largely based upon distance from the mob

		if ( nextPos > WeDontWipeDB.queueLength ) or ( hyRange == false ) then return end

		hyMin = ( ignore == "y" ) and 0 or ( hyMin + range )	-- Reverts to original Hard Yards value

		if ( ( ignore == "y" ) or ( hyMin  > ( 15 - range ) ) and ( hyMin <= ( 30 + range ) ) ) and ( cdLeftThrow1 ~= -1 ) and ( IsSpellKnown( 185123 ) == true ) then

			local cdLeftTG = WeDontWipe_CooldownLeft( 185123 )
			if ( ( cdLeftTG - wait ) < elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 185123									-- Throw Glaive
				nextPos = nextPos + 1
				return
			end
		end

		if ( ignore == "y" ) or ( hyMin <= ( 5 + range ) ) then

			if ( cdLeftFR >= 0 ) and ( ( cdLeftFR - wait - wdw_GCDtop ) < elapsedNextPos ) then
				if ( cdLeftVR >= 0 ) and ( ( cdLeftVR - wait ) < elapsedNextPos ) then
					wdw_Queue[ nextPos ] = 198793								-- Vengeful Retreat
					nextPos = nextPos + 1
					if ( nextPos <= WeDontWipeDB.queueLength ) then
						wdw_Queue[ nextPos ] = 195072							-- Fel Rush
						nextPos = nextPos + 1
					end
					return
				end
			end
			if ( demonBladesKnown == false ) and ( furyCurrent + 25 <= furyMax ) then
				wdw_Queue[ nextPos ] = 162243									-- Demon's Bite
				nextPos = nextPos + 1
				return
			end
		end

		if ( cdLeftFR >= 0 ) and ( ( cdLeftFR - wait ) < elapsedNextPos ) and ( ( ignore == "y" ) or ( overshoot == "y" ) or ( overshootMin >= 10 ) ) then
			wdw_Queue[ nextPos ] = 195072										-- Fel Rush
			nextPos = nextPos + 1
		end
	end,

	["Final"] = function ()

		for i = nextPos, WeDontWipeDB.queueLength do
			wdw_Queue[ i ] = uptoyou
		end
	end,

}



















